## 2.0.5

- Updated [prebuilt libraries](lib/src/zstd/blobs) to [ZSTD v1.5.2](https://github.com/facebook/zstd/releases/tag/v1.5.2).

## 2.0.4

- Enhanced Android library resolution (special thanks to [mejdi14](https://github.com/mejdi14) for providing this).
- Linter updates and code cleanup

## 2.0.3

- Updated [prebuilt libraries](lib/src/zstd/blobs) to [ZSTD v1.5.0](https://github.com/facebook/zstd/releases/tag/v1.5.0).
- Move CI to Github Actions

## 2.0.2

- Fix ios dynamic library resolution in [open_library.dart](lib/src/framework/native/library/open_library.dart)
- Updated constraints to >=2.12.0 <3.0.0.

## 2.0.1

- Updated [prebuilt libraries](lib/src/zstd/blobs) to [ZSTD v1.4.9](https://github.com/facebook/zstd/releases/tag/v1.4.9).
- Comment tweaks.

## 2.0.0

- Stable null safety release.
- Updated constraints to >=2.12.0-0 <3.0.0.
- Migrate `package:ffi` `Allocator` uses (removed temporary internal malloc/free).
- Migrate `package:ffi` `Utf8` uses.
- Update copyright year

## 2.0.0-nullsafety.0

- Migrate to null safety
- Updated memory allocation due to FFI breaking changes.
- Updated empty structs (implicit opaque) to subclass new FFI Opaque native type.
- Update SDK constraints to >=2.12.0-253 <3.0.0 based on beta release guidelines.

## 1.0.0

- New examples for building the provided native libraries on Android (special thanks to [isong0623](https://github.com/isong0623) for providing this).
- Updated [prebuilt libraries](lib/src/zstd/blobs) to [ZSTD v1.4.8](https://github.com/facebook/zstd/releases/tag/v1.4.8).
- Updated the default build mode in [cmake instructions](tool/blob_builder/CMakeLists.txt) to be Release mode.

## 0.9.9

- Fixed List initializer issues reported by dart static analysis on pub.dev

## 0.9.8

- Updated [prebuilt libraries](lib/src/lz4/blobs) to [LZ4 v1.9.3](https://github.com/lz4/lz4/releases/tag/v1.9.3).
- Rebuilt mac 64-bit libraries for win/linux/mac using xcode project.
- Updated [cmake instructions](tool/blob_builder/CMakeLists.txt) for building prebuilt libraries on mac.
- Fix comments.

## 0.9.7

- **(Breaking Change: Codec Users)** Removed (user-override library) path argument in constructors for BrotliCodec, Lz4Codec
and ZstdCodec in favor of static getters/setters BrotliCodec.libraryPath, Lz4Codec.libraryPath, ZstdCodec.libraryPath. 
- Refactored [open_library.dart](lib/src/framework/native/library/open_library.dart) by splitting out the various shared
library resolving mechanisms into an ordered list of strategy objects.
- Stubbed [OpenViaPackageRelativeStrategy](lib/src/framework/native/library/stubs/package_relative_strategy.dart) to more
easily allow for use within flutter.
- CMake corrections to allow for building Android shared libraries on Win/Clang/Ninja configurations.
- Updated readme with more information on shared library resolution.

## 0.9.6

- Refactored and provided stubs for native/js library import compat.
- Additional comments.

## 0.9.5

- Extended library export for direct access to encoder/decoder/version/option objects.
- Visibility tweaks to library constants to resolve conflicts.
- Fix broken links generated by dartdoc

## 0.9.4

- Relaxed platform restrictions in shared library loader.
- Cosmetic tweaks to [README.md](README.md).

## 0.9.3

- **(Breaking Change: Codec Implementors)** bool positionable param -> named param in `CodecBuffer.resetRead()`
and `CodecBuffer.resetWrite()`.
- Tweaks based on feedback from *effective_dart* analysis.

## 0.9.2

- Refactored and provided stubs for native/js library import compat.
- Fix stats printing in `escompress` for sub-second conversions.

## 0.9.1

- **(Breaking Change: Codec Implementors)** Removed class generic type from `CodecFilter` class.
- Created extendable base class for FFI-based codec filters: [NativeCodecFilterBase](lib/src/framework/native/filters.dart).
- Created extendable base class for non-FFI codec filters: [DartCodecFilterBase](lib/src/framework/dart/filters.dart).
- Refactored existing codec filters to subclass `NativeCodecFilterBase` and `DartCodecFilterBase`.
- Fixed some minor issues with the [README](README.md).

## 0.9.0

- Initial development release, created by Seth Berman [Instantiations, Inc](https://www.instantiations.com).
- Implemented general codec framework.
- Implemented FFI read/write streamable buffers.
- Implemented Dart Heap read/write streamable buffers.
- Implemented flexible library loading with [OpenLibrary](lib/src/framework/native/library/open_library.dart) mixin.
- Implemented FFI bindings for [Brotli v1.0.9](https://github.com/google/brotli/tree/v1.0.9).
- Implemented Brotli codec framework extensions (encoder/decoders).
- Implemented shared library and Brotli [Cmake build instructions](tool/blob_builder/brotli/CMakeLists.txt).
- Provided prebuilt [Win64 Brotli native shared library](lib/src/brotli/blobs/esbrotli-win64.dll).
- Provided prebuilt [Linux64 Brotli native shared library](lib/src/brotli/blobs/esbrotli-linux64.so).
- Provided prebuilt [Mac64 Brotli native shared library](lib/src/brotli/blobs/esbrotli-mac64.dylib).
- Implemented [Brotli examples](example/brotli_example.dart).
- Implemented [Brotli benchmarks](benchmark/brotli_benchmark.dart).
- Implemented [Brotli tests](test/brotli_test.dart).
- Implemented FFI bindings for [LZ4 v1.9.2](https://github.com/lz4/lz4/tree/v1.9.2).
- Implemented LZ4 codec framework extensions (encoder/decoders).
- Implemented shared library and LZ4 [Cmake build instructions](tool/blob_builder/lz4/CMakeLists.txt).
- Provided prebuilt [Win64 LZ4 native shared library](lib/src/lz4/blobs/eslz4-win64.dll).
- Provided prebuilt [Linux64 LZ4 native shared library](lib/src/lz4/blobs/eslz4-linux64.so).
- Provided prebuilt [Mac64 LZ4 native shared library](lib/src/lz4/blobs/eslz4-mac64.dylib).
- Implemented [LZ4 examples](example/lz4_example.dart).
- Implemented [LZ4 benchmarks](benchmark/lz4_benchmark.dart).
- Implemented [LZ4 tests](test/lz4_test.dart).
- Implemented FFI bindings for [Zstd v1.4.5](https://github.com/facebook/zstd/tree/v1.4.5).
- Implemented ZStandard (zstd) codec framework extensions (encoder/decoders).
- Implemented shared library and Zstd [Cmake build instructions](tool/blob_builder/zstd/CMakeLists.txt).
- Provided prebuilt [Win64 Zstd native shared library](lib/src/zstd/blobs/eszstd-win64.dll).
- Provided prebuilt [Linux64 Zstd native shared library](lib/src/zstd/blobs/eszstd-linux64.so).
- Provided prebuilt [Mac64 Zstd native shared library](lib/src/zstd/blobs/eszstd-mac64.dylib).
- Implemented [Zstd examples](example/zstd_example.dart).
- Implemented [Zstd benchmarks](benchmark/zstd_benchmark.dart).
- Implemented [Zstd tests](test/zstd_test.dart).
- Implemented [escompress](bin/es_compress.dart) binary script with gzip, lz4, zstd, brotli integration.
- Implemented [Compression framework examples](example/rle_example.dart).
- Implemented version objects for each codec that allow the user to easily see what library was bound to.
- Implemented tests for [escompress](bin/es_compress.dart), [examples](example) and [benchmarks](benchmark).
- Produced initial [design doc](doc/design_doc.md) and experience report.
